<center><a href="ex2.c">Actual source code: ex2.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:31:03+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Newton method to solve u'' + u^{2} = f, sequentially.\n\</font>
<a name="line3">  3: </a><font color="#666666">This example employs a user-defined monitoring routine.\n\n"</font>;

<a name="line5">  5: </a><font color="#B22222">/*T</font>
<a name="line6">  6: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>^basic uniprocessor example</font>
<a name="line7">  7: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>^setting a user-defined monitoring routine</font>
<a name="line8">  8: </a><font color="#B22222">   Processors: 1</font>
<a name="line9">  9: </a><font color="#B22222">T*/</font>

<a name="line11"> 11: </a><font color="#B22222">/* </font>
<a name="line12"> 12: </a><font color="#B22222">   Include "petscdraw.h" so that we can use PETSc drawing routines.</font>
<a name="line13"> 13: </a><font color="#B22222">   Include "petscsnes.h" so that we can use <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> solvers.  Note that this</font>
<a name="line14"> 14: </a><font color="#B22222">   file automatically includes:</font>
<a name="line15"> 15: </a><font color="#B22222">     petsc.h       - base PETSc routines   petscvec.h - vectors</font>
<a name="line16"> 16: </a><font color="#B22222">     petscsys.h    - system routines       petscmat.h - matrices</font>
<a name="line17"> 17: </a><font color="#B22222">     petscis.h     - index sets            petscksp.h - Krylov subspace methods</font>
<a name="line18"> 18: </a><font color="#B22222">     petscviewer.h - viewers               petscpc.h  - preconditioners</font>
<a name="line19"> 19: </a><font color="#B22222">     petscksp.h   - linear solvers</font>
<a name="line20"> 20: </a><font color="#B22222">*/</font>

<a name="line22"> 22: </a> #include <A href="../../../../include/petscsnes.h.html">petscsnes.h</A>

<a name="line24"> 24: </a><font color="#B22222">/* </font>
<a name="line25"> 25: </a><font color="#B22222">   User-defined routines</font>
<a name="line26"> 26: </a><font color="#B22222">*/</font>

<a name="line32"> 32: </a><font color="#B22222">/*</font>
<a name="line33"> 33: </a><font color="#B22222">   User-defined context for monitoring</font>
<a name="line34"> 34: </a><font color="#B22222">*/</font>
<a name="line35"> 35: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line36"> 36: </a>   <A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer;
<a name="line37"> 37: </a>} MonitorCtx;

<a name="line41"> 41: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line42"> 42: </a>{
<a name="line43"> 43: </a>  <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>           snes;                   <font color="#B22222">/* <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> context */</font>
<a name="line44"> 44: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            x,r,F,U;             <font color="#B22222">/* vectors */</font>
<a name="line45"> 45: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            J;                      <font color="#B22222">/* Jacobian matrix */</font>
<a name="line46"> 46: </a>  MonitorCtx     monP;                   <font color="#B22222">/* monitoring context */</font>
<a name="line48"> 48: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       its,n = 5,i,maxit,maxf;
<a name="line49"> 49: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line50"> 50: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    h,xp,v,none = -1.0;
<a name="line51"> 51: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      abstol,rtol,stol,norm;

<a name="line53"> 53: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char *)0,help);
<a name="line54"> 54: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line55"> 55: </a>  <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/size.html#size">size</A> != 1) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"This is a uniprocessor example only!"</font>);
<a name="line56"> 56: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-n"</font>,&amp;n,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line57"> 57: </a>  h = 1.0/(n-1);

<a name="line59"> 59: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line60"> 60: </a><font color="#B22222">     Create nonlinear solver context</font>
<a name="line61"> 61: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line63"> 63: </a>  <A href="../../../../docs/manualpages/SNES/SNESCreate.html#SNESCreate">SNESCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;snes);

<a name="line65"> 65: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line66"> 66: </a><font color="#B22222">     Create vector data structures; set function evaluation routine</font>
<a name="line67"> 67: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line68"> 68: </a>  <font color="#B22222">/*</font>
<a name="line69"> 69: </a><font color="#B22222">     Note that we form 1 vector from scratch and then duplicate as needed.</font>
<a name="line70"> 70: </a><font color="#B22222">  */</font>
<a name="line71"> 71: </a>  <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;x);
<a name="line72"> 72: </a>  <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(x,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,n);
<a name="line73"> 73: </a>  <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(x);
<a name="line74"> 74: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(x,&amp;r);
<a name="line75"> 75: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(x,&amp;F);
<a name="line76"> 76: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(x,&amp;U);

<a name="line78"> 78: </a>  <font color="#B22222">/* </font>
<a name="line79"> 79: </a><font color="#B22222">     Set function evaluation routine and vector</font>
<a name="line80"> 80: </a><font color="#B22222">  */</font>
<a name="line81"> 81: </a>  <A href="../../../../docs/manualpages/SNES/SNESSetFunction.html#SNESSetFunction">SNESSetFunction</A>(snes,r,FormFunction,(void*)F);


<a name="line84"> 84: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line85"> 85: </a><font color="#B22222">     Create matrix data structure; set Jacobian evaluation routine</font>
<a name="line86"> 86: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line88"> 88: </a>  <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;J);
<a name="line89"> 89: </a>  <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(J,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,n,n);
<a name="line90"> 90: </a>  <A href="../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>(J);

<a name="line92"> 92: </a>  <font color="#B22222">/* </font>
<a name="line93"> 93: </a><font color="#B22222">     Set Jacobian matrix data structure and default Jacobian evaluation</font>
<a name="line94"> 94: </a><font color="#B22222">     routine. User can override with:</font>
<a name="line95"> 95: </a><font color="#B22222">     -snes_fd : default finite differencing approximation of Jacobian</font>
<a name="line96"> 96: </a><font color="#B22222">     -snes_mf : matrix-free Newton-Krylov method with no preconditioning</font>
<a name="line97"> 97: </a><font color="#B22222">                (unless user explicitly sets preconditioner) </font>
<a name="line98"> 98: </a><font color="#B22222">     -snes_mf_operator : form preconditioning matrix as set by the user,</font>
<a name="line99"> 99: </a><font color="#B22222">                         but use matrix-free approx for Jacobian-vector</font>
<a name="line100">100: </a><font color="#B22222">                         products within Newton-Krylov method</font>
<a name="line101">101: </a><font color="#B22222">  */</font>

<a name="line103">103: </a>  <A href="../../../../docs/manualpages/SNES/SNESSetJacobian.html#SNESSetJacobian">SNESSetJacobian</A>(snes,J,J,FormJacobian,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line105">105: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line106">106: </a><font color="#B22222">     Customize nonlinear solver; set runtime options</font>
<a name="line107">107: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line109">109: </a>  <font color="#B22222">/* </font>
<a name="line110">110: </a><font color="#B22222">     Set an optional user-defined monitoring routine</font>
<a name="line111">111: </a><font color="#B22222">  */</font>
<a name="line112">112: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,0,0,0,0,400,400,&amp;monP.viewer);
<a name="line113">113: </a>  <A href="../../../../docs/manualpages/SNES/SNESSetMonitor.html#SNESSetMonitor">SNESSetMonitor</A>(snes,Monitor,&amp;monP,0);

<a name="line115">115: </a>  <font color="#B22222">/*</font>
<a name="line116">116: </a><font color="#B22222">     Set names for some vectors to facilitate monitoring (optional)</font>
<a name="line117">117: </a><font color="#B22222">  */</font>
<a name="line118">118: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectSetName.html#PetscObjectSetName">PetscObjectSetName</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)x,<font color="#666666">"Approximate Solution"</font>);
<a name="line119">119: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectSetName.html#PetscObjectSetName">PetscObjectSetName</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)U,<font color="#666666">"Exact Solution"</font>);

<a name="line121">121: </a>  <font color="#B22222">/* </font>
<a name="line122">122: </a><font color="#B22222">     Set <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>/<A href="../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>/<A href="../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>/<A href="../../../../docs/manualpages/PC/PC.html#PC">PC</A> runtime options, e.g.,</font>
<a name="line123">123: </a><font color="#B22222">         -snes_view -snes_monitor -ksp_type &lt;ksp&gt; -pc_type &lt;pc&gt;</font>
<a name="line124">124: </a><font color="#B22222">  */</font>
<a name="line125">125: </a>  <A href="../../../../docs/manualpages/SNES/SNESSetFromOptions.html#SNESSetFromOptions">SNESSetFromOptions</A>(snes);

<a name="line127">127: </a>  <font color="#B22222">/* </font>
<a name="line128">128: </a><font color="#B22222">     Print parameters used for convergence testing (optional) ... just</font>
<a name="line129">129: </a><font color="#B22222">     to demonstrate this routine; this information is also printed with</font>
<a name="line130">130: </a><font color="#B22222">     the option -snes_view</font>
<a name="line131">131: </a><font color="#B22222">  */</font>
<a name="line132">132: </a>  <A href="../../../../docs/manualpages/SNES/SNESGetTolerances.html#SNESGetTolerances">SNESGetTolerances</A>(snes,&amp;abstol,&amp;rtol,&amp;stol,&amp;maxit,&amp;maxf);
<a name="line133">133: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"atol=%G, rtol=%G, stol=%G, maxit=%D, maxf=%D\n"</font>,abstol,rtol,stol,maxit,maxf);

<a name="line135">135: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line136">136: </a><font color="#B22222">     Initialize application:</font>
<a name="line137">137: </a><font color="#B22222">     Store right-hand-side of PDE and exact solution</font>
<a name="line138">138: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line140">140: </a>  xp = 0.0;
<a name="line141">141: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line142">142: </a>    v = 6.0*xp + PetscPowScalar(xp+1.e-12,6.0); <font color="#B22222">/* +1.e-12 is to prevent 0^6 */</font>
<a name="line143">143: </a>    <A href="../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(F,1,&amp;i,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line144">144: </a>    v= xp*xp*xp;
<a name="line145">145: </a>    <A href="../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(U,1,&amp;i,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line146">146: </a>    xp += h;
<a name="line147">147: </a>  }

<a name="line149">149: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line150">150: </a><font color="#B22222">     Evaluate initial guess; then solve nonlinear system</font>
<a name="line151">151: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line152">152: </a>  <font color="#B22222">/*</font>
<a name="line153">153: </a><font color="#B22222">     Note: The user should initialize the vector, x, with the initial guess</font>
<a name="line154">154: </a><font color="#B22222">     for the nonlinear solver prior to calling <A href="../../../../docs/manualpages/SNES/SNESSolve.html#SNESSolve">SNESSolve</A>().  In particular,</font>
<a name="line155">155: </a><font color="#B22222">     to employ an initial guess of zero, the user should explicitly set</font>
<a name="line156">156: </a><font color="#B22222">     this vector to zero by calling <A href="../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>().</font>
<a name="line157">157: </a><font color="#B22222">  */</font>
<a name="line158">158: </a>  FormInitialGuess(x);
<a name="line159">159: </a>  <A href="../../../../docs/manualpages/SNES/SNESSolve.html#SNESSolve">SNESSolve</A>(snes,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,x);
<a name="line160">160: </a>  <A href="../../../../docs/manualpages/SNES/SNESGetIterationNumber.html#SNESGetIterationNumber">SNESGetIterationNumber</A>(snes,&amp;its);
<a name="line161">161: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"number of Newton iterations = %D\n\n"</font>,its);

<a name="line163">163: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line164">164: </a><font color="#B22222">     Check solution and clean up</font>
<a name="line165">165: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line167">167: </a>  <font color="#B22222">/* </font>
<a name="line168">168: </a><font color="#B22222">     Check the error</font>
<a name="line169">169: </a><font color="#B22222">  */</font>
<a name="line170">170: </a>  <A href="../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(x,none,U);
<a name="line171">171: </a>  <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(x,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm);
<a name="line172">172: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"Norm of error %A, Iterations %D\n"</font>,norm,its);


<a name="line175">175: </a>  <font color="#B22222">/*</font>
<a name="line176">176: </a><font color="#B22222">     Free work space.  All PETSc objects should be destroyed when they</font>
<a name="line177">177: </a><font color="#B22222">     are no longer needed.</font>
<a name="line178">178: </a><font color="#B22222">  */</font>
<a name="line179">179: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x);  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(r);
<a name="line180">180: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(U);  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(F);
<a name="line181">181: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(J);  <A href="../../../../docs/manualpages/SNES/SNESDestroy.html#SNESDestroy">SNESDestroy</A>(snes);
<a name="line182">182: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(monP.viewer);
<a name="line183">183: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();

<a name="line185">185: </a>  <font color="#4169E1">return</font> 0;
<a name="line186">186: </a>}
<a name="line187">187: </a><font color="#B22222">/* ------------------------------------------------------------------- */</font>
<a name="line190">190: </a><font color="#B22222">/*</font>
<a name="line191">191: </a><font color="#B22222">   FormInitialGuess - Computes initial guess.</font>

<a name="line193">193: </a><font color="#B22222">   Input/Output Parameter:</font>
<a name="line194">194: </a><font color="#B22222">.  x - the solution vector</font>
<a name="line195">195: </a><font color="#B22222">*/</font>
<a name="line196">196: </a><strong><font color="#4169E1"><a name="FormInitialGuess"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> FormInitialGuess(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x)</font></strong>
<a name="line197">197: </a>{
<a name="line199">199: </a>   <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    pfive = .50;
<a name="line200">200: </a>   <A href="../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(x,pfive);
<a name="line201">201: </a>   <font color="#4169E1">return</font> 0;
<a name="line202">202: </a>}
<a name="line203">203: </a><font color="#B22222">/* ------------------------------------------------------------------- */</font>
<a name="line206">206: </a><font color="#B22222">/* </font>
<a name="line207">207: </a><font color="#B22222">   FormFunction - Evaluates nonlinear function, F(x).</font>

<a name="line209">209: </a><font color="#B22222">   Input Parameters:</font>
<a name="line210">210: </a><font color="#B22222">.  snes - the <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> context</font>
<a name="line211">211: </a><font color="#B22222">.  x - input vector</font>
<a name="line212">212: </a><font color="#B22222">.  ctx - optional user-defined context, as set by <A href="../../../../docs/manualpages/SNES/SNESSetFunction.html#SNESSetFunction">SNESSetFunction</A>()</font>

<a name="line214">214: </a><font color="#B22222">   Output Parameter:</font>
<a name="line215">215: </a><font color="#B22222">.  f - function vector</font>

<a name="line217">217: </a><font color="#B22222">   Note:</font>
<a name="line218">218: </a><font color="#B22222">   The user-defined context can contain any application-specific data</font>
<a name="line219">219: </a><font color="#B22222">   needed for the function evaluation (such as various parameters, work</font>
<a name="line220">220: </a><font color="#B22222">   vectors, and grid information).  In this program the context is just</font>
<a name="line221">221: </a><font color="#B22222">   a vector containing the right-hand-side of the discretized PDE.</font>
<a name="line222">222: </a><font color="#B22222"> */</font>

<a name="line224">224: </a><strong><font color="#4169E1"><a name="FormFunction"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> FormFunction(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> f,void *ctx)</font></strong>
<a name="line225">225: </a>{
<a name="line226">226: </a>   <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            g = (<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)ctx;
<a name="line227">227: </a>   <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *xx,*ff,*gg,d;
<a name="line229">229: </a>   <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n;

<a name="line231">231: </a>  <font color="#B22222">/*</font>
<a name="line232">232: </a><font color="#B22222">     Get pointers to vector data.</font>
<a name="line233">233: </a><font color="#B22222">       - For default PETSc vectors, <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>() returns a pointer to</font>
<a name="line234">234: </a><font color="#B22222">         the data array.  Otherwise, the routine is implementation dependent.</font>
<a name="line235">235: </a><font color="#B22222">       - You MUST call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>() when you no longer need access to</font>
<a name="line236">236: </a><font color="#B22222">         the array.</font>
<a name="line237">237: </a><font color="#B22222">  */</font>
<a name="line238">238: </a>   <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;xx);
<a name="line239">239: </a>   <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(f,&amp;ff);
<a name="line240">240: </a>   <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(g,&amp;gg);

<a name="line242">242: </a>  <font color="#B22222">/*</font>
<a name="line243">243: </a><font color="#B22222">     Compute function</font>
<a name="line244">244: </a><font color="#B22222">  */</font>
<a name="line245">245: </a>   <A href="../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(x,&amp;n);
<a name="line246">246: </a>   d = (<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(n - 1); d = d*d;
<a name="line247">247: </a>   ff[0]   = xx[0];
<a name="line248">248: </a>   <font color="#4169E1">for</font> (i=1; i&lt;n-1; i++) {
<a name="line249">249: </a>     ff[i] = d*(xx[i-1] - 2.0*xx[i] + xx[i+1]) + xx[i]*xx[i] - gg[i];
<a name="line250">250: </a>   }
<a name="line251">251: </a>   ff[n-1] = xx[n-1] - 1.0;

<a name="line253">253: </a>  <font color="#B22222">/*</font>
<a name="line254">254: </a><font color="#B22222">     Restore vectors</font>
<a name="line255">255: </a><font color="#B22222">  */</font>
<a name="line256">256: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;xx);
<a name="line257">257: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(f,&amp;ff);
<a name="line258">258: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(g,&amp;gg);
<a name="line259">259: </a>  <font color="#4169E1">return</font> 0;
<a name="line260">260: </a>}
<a name="line261">261: </a><font color="#B22222">/* ------------------------------------------------------------------- */</font>
<a name="line264">264: </a><font color="#B22222">/*</font>
<a name="line265">265: </a><font color="#B22222">   FormJacobian - Evaluates Jacobian matrix.</font>

<a name="line267">267: </a><font color="#B22222">   Input Parameters:</font>
<a name="line268">268: </a><font color="#B22222">.  snes - the <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> context</font>
<a name="line269">269: </a><font color="#B22222">.  x - input vector</font>
<a name="line270">270: </a><font color="#B22222">.  dummy - optional user-defined context (not used here)</font>

<a name="line272">272: </a><font color="#B22222">   Output Parameters:</font>
<a name="line273">273: </a><font color="#B22222">.  jac - Jacobian matrix</font>
<a name="line274">274: </a><font color="#B22222">.  B - optionally different preconditioning matrix</font>
<a name="line275">275: </a><font color="#B22222">.  flag - flag indicating matrix structure</font>
<a name="line276">276: </a><font color="#B22222">*/</font>

<a name="line278">278: </a><strong><font color="#4169E1"><a name="FormJacobian"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> FormJacobian(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *jac,<A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *B,<A href="../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A>*flag,void *dummy)</font></strong>
<a name="line279">279: </a>{
<a name="line280">280: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *xx,A[3],d;
<a name="line282">282: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n,j[3];

<a name="line284">284: </a>  <font color="#B22222">/*</font>
<a name="line285">285: </a><font color="#B22222">     Get pointer to vector data</font>
<a name="line286">286: </a><font color="#B22222">  */</font>
<a name="line287">287: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;xx);

<a name="line289">289: </a>  <font color="#B22222">/*</font>
<a name="line290">290: </a><font color="#B22222">     Compute Jacobian entries and insert into matrix.</font>
<a name="line291">291: </a><font color="#B22222">      - Note that in this case we set all elements for a particular</font>
<a name="line292">292: </a><font color="#B22222">        row at once.</font>
<a name="line293">293: </a><font color="#B22222">  */</font>
<a name="line294">294: </a>  <A href="../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(x,&amp;n);
<a name="line295">295: </a>  d = (<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(n - 1); d = d*d;

<a name="line297">297: </a>  <font color="#B22222">/*</font>
<a name="line298">298: </a><font color="#B22222">     Interior grid points</font>
<a name="line299">299: </a><font color="#B22222">  */</font>
<a name="line300">300: </a>  <font color="#4169E1">for</font> (i=1; i&lt;n-1; i++) {
<a name="line301">301: </a>    j[0] = i - 1; j[1] = i; j[2] = i + 1;
<a name="line302">302: </a>    A[0] = A[2] = d; A[1] = -2.0*d + 2.0*xx[i];
<a name="line303">303: </a>    <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(*jac,1,&amp;i,3,j,A,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line304">304: </a>  }

<a name="line306">306: </a>  <font color="#B22222">/*</font>
<a name="line307">307: </a><font color="#B22222">     Boundary points</font>
<a name="line308">308: </a><font color="#B22222">  */</font>
<a name="line309">309: </a>  i = 0;   A[0] = 1.0;
<a name="line310">310: </a>  <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(*jac,1,&amp;i,1,&amp;i,A,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line311">311: </a>  i = n-1; A[0] = 1.0;
<a name="line312">312: </a>  <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(*jac,1,&amp;i,1,&amp;i,A,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);

<a name="line314">314: </a>  <font color="#B22222">/*</font>
<a name="line315">315: </a><font color="#B22222">     Restore vector</font>
<a name="line316">316: </a><font color="#B22222">  */</font>
<a name="line317">317: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;xx);

<a name="line319">319: </a>  <font color="#B22222">/*</font>
<a name="line320">320: </a><font color="#B22222">     Assemble matrix</font>
<a name="line321">321: </a><font color="#B22222">  */</font>
<a name="line322">322: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(*jac,MAT_FINAL_ASSEMBLY);
<a name="line323">323: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(*jac,MAT_FINAL_ASSEMBLY);

<a name="line325">325: </a>  <font color="#4169E1">return</font> 0;
<a name="line326">326: </a>}
<a name="line327">327: </a><font color="#B22222">/* ------------------------------------------------------------------- */</font>
<a name="line330">330: </a><font color="#B22222">/*</font>
<a name="line331">331: </a><font color="#B22222">   Monitor - User-defined monitoring routine that views the</font>
<a name="line332">332: </a><font color="#B22222">   current iterate with an x-window plot.</font>

<a name="line334">334: </a><font color="#B22222">   Input Parameters:</font>
<a name="line335">335: </a><font color="#B22222">   snes - the <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> context</font>
<a name="line336">336: </a><font color="#B22222">   its - iteration number</font>
<a name="line337">337: </a><font color="#B22222">   norm - 2-norm function value (may be estimated)</font>
<a name="line338">338: </a><font color="#B22222">   ctx - optional user-defined context for private data for the </font>
<a name="line339">339: </a><font color="#B22222">         monitor routine, as set by <A href="../../../../docs/manualpages/SNES/SNESSetMonitor.html#SNESSetMonitor">SNESSetMonitor</A>()</font>

<a name="line341">341: </a><font color="#B22222">   Note:</font>
<a name="line342">342: </a><font color="#B22222">   See the manpage for <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>() for useful runtime options,</font>
<a name="line343">343: </a><font color="#B22222">   such as -nox to deactivate all x-window output.</font>
<a name="line344">344: </a><font color="#B22222"> */</font>
<a name="line345">345: </a><strong><font color="#4169E1"><a name="Monitor"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> Monitor(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> its,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> fnorm,void *ctx)</font></strong>
<a name="line346">346: </a>{
<a name="line348">348: </a>  MonitorCtx     *monP = (MonitorCtx*) ctx;
<a name="line349">349: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            x;

<a name="line351">351: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"iter = %D, <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> Function norm %G\n"</font>,its,fnorm);
<a name="line352">352: </a>  <A href="../../../../docs/manualpages/SNES/SNESGetSolution.html#SNESGetSolution">SNESGetSolution</A>(snes,&amp;x);
<a name="line353">353: </a>  <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(x,monP-&gt;viewer);
<a name="line354">354: </a>  <font color="#4169E1">return</font> 0;
<a name="line355">355: </a>}
</pre>
</body>

</html>
